diff -ru --unidirectional-new-file footools-x86-x64-20111102/CHANGELOG footools-x86-x64-20111102-mp3genre/CHANGELOG
--- footools-x86-x64-20111102/CHANGELOG	2013-12-20 21:09:04.000000000 +0100
+++ footools-x86-x64-20111102-mp3genre/CHANGELOG	2013-12-20 21:09:04.000000000 +0100
@@ -70,3 +70,6 @@
              * Fixed chroot gentoo bug for foo-pre.
              * Added a little help file.
 Nov  2 2011: * Fixed a bug about "you're not in any of your predir" :)
+
+//slv
+Aug 08 2012: * MP3 genre added to PRE output (instead of in mod_idmp3)
diff -ru --unidirectional-new-file footools-x86-x64-20111102/src/CHANGES footools-x86-x64-20111102-mp3genre/src/CHANGES
--- footools-x86-x64-20111102/src/CHANGES	2013-12-20 21:09:04.000000000 +0100
+++ footools-x86-x64-20111102-mp3genre/src/CHANGES	2013-12-20 21:09:04.000000000 +0100
@@ -70,3 +70,6 @@
              * Fixed chroot gentoo bug for foo-pre.
              * Added a little help file.
 Nov  2 2011: * Fixed a bug about "you're not in any of your predir" :)
+
+//slv
+Aug 08 2012: * MP3 genre added to PRE output (instead of in mod_idmp3)
diff -ru --unidirectional-new-file footools-x86-x64-20111102/src/pre/foo-pre.c footools-x86-x64-20111102-mp3genre/src/pre/foo-pre.c
--- footools-x86-x64-20111102/src/pre/foo-pre.c	2013-12-20 21:09:04.000000000 +0100
+++ footools-x86-x64-20111102-mp3genre/src/pre/foo-pre.c	2013-12-20 21:09:04.000000000 +0100
@@ -20,6 +20,7 @@
  */
 /*
  *  foo.Pre [C-version]  (c)  tanesha team, <tanesha@tanesha.net>
+    slv 02082012 - mp3 genre added to PRE output (instead of in mod_idmp3)
  */
 #include <stdio.h>
 #include <stdlib.h>
@@ -44,7 +45,8 @@
 #include "foo-pre.h"
 #include "gl_userfile.h"
 
-#define VERSION "$Id: foo-pre.c,v 1.18 2004/09/28 06:52:24 sorend Exp $"
+//#define VERSION "$Id: foo-pre.c,v 1.18 2004/09/28 06:52:24 sorend Exp $"
+#define VERSION "$Id: foo-pre.c,v 1.19 2012/08/03 17:46:00 sorend, slv Exp $"
 #define USAGE " * Syntax: SITE PRE <RELEASEDIR> [SECTION]\n"
 
 void quit(char *s, ...);
@@ -53,6 +55,8 @@
 hashtable_t *_config = 0;
 hashtable_t *_envctx = 0;
 
+char *id3_genre;
+
 /*
  * Acecssor method for configuration.
  */
@@ -1030,6 +1034,19 @@
 	printf("   -- %10.10s: %s\n", "From", src);
 	printf("   -- %10.10s: %s", "To", dest);
 
+        /*
+   	 * slv 02082012 - get filename.mp3 and call get_mp3_genre(filename).
+         */
+	// get genre.
+        for (ftmp = files; ftmp; ftmp = ftmp->next) {
+		tmp = strrchr(ftmp->file, '.');
+		if (!strcmp(tmp, ".mp3")) {
+			sprintf(buf, "%s/%s", src, ftmp->file);
+			get_mp3_genre(buf);
+			break;
+		}
+	}
+
 	// dont forget to chown maindir
 	chowninfo_apply_to_file(src, chown);
 
@@ -1087,6 +1104,7 @@
 		pre_replace(buf, "%g", ht_get(env, PROPERTY_USERGROUP));
 		pre_replace(buf, "%D", section_get_property(section, PROPERTY_SECTION_NAME));
 		pre_replace(buf, "%R", rel);
+		pre_replace(buf, "%I", id3_genre);
 
 		gl_gllog_add(buf);
 
@@ -1347,10 +1365,10 @@
 	}
 
 	// log DONE: "<preuser>" "<pregroup>" "<release>" "<destinationdir>"
-	pre_log("DONE", "\"%s\" \"%s\" \"%s\" \"%s\"",
+	//slv added: "<genre>"
+	pre_log("DONE", "\"%s\" \"%s\" \"%s\" \"%s\" \"%s\"",
 			ht_get(env, PROPERTY_USER), group,
-			argv[1], destpath);
-
+			argv[1], destpath, id3_genre);
 	return 0;
 }
 
diff -ru --unidirectional-new-file footools-x86-x64-20111102/src/pre/Makefile footools-x86-x64-20111102-mp3genre/src/pre/Makefile
--- footools-x86-x64-20111102/src/pre/Makefile	2013-12-20 21:09:04.000000000 +0100
+++ footools-x86-x64-20111102-mp3genre/src/pre/Makefile	2013-12-20 21:09:04.000000000 +0100
@@ -4,10 +4,10 @@
 
 SRCDIR = ..
 
-LIBS = ../collection/strlist.o ../lib/gllogs.o ../lib/pwdfile.o ../util/linefilereader.o ../collection/hashtable.o ../lib/stringtokenizer.o ./gl_userfile.o
+LIBS = ../collection/strlist.o ../lib/gllogs.o ../lib/pwdfile.o ../util/linefilereader.o ../collection/hashtable.o ../lib/stringtokenizer.o ./gl_userfile.o ./mp3genre/mp3genre.o
 
 foo-pre: foo-pre.o $(LIBS)
-	$(CC) -o $@ $< $(LIBS) -ldl
+	$(CC) -o $@ $< mp3genre/mp3genre.o $(LIBS) -ldl
 
 foo.Pre: foo.Pre.o
 	$(CC) -o $@ $< $(LIBS)
diff -ru --unidirectional-new-file footools-x86-x64-20111102/src/pre/Makefile.in footools-x86-x64-20111102-mp3genre/src/pre/Makefile.in
--- footools-x86-x64-20111102/src/pre/Makefile.in	2013-12-20 21:09:04.000000000 +0100
+++ footools-x86-x64-20111102-mp3genre/src/pre/Makefile.in	2013-12-20 21:09:04.000000000 +0100
@@ -7,7 +7,7 @@
 LIBS = ../collection/strlist.o ../lib/gllogs.o ../lib/pwdfile.o ../util/linefilereader.o ../collection/hashtable.o ../lib/stringtokenizer.o ./gl_userfile.o
 
 foo-pre: foo-pre.o $(LIBS)
-	$(CC) -o $@ $< $(LIBS) -ldl
+	$(CC) -o $@ $< mp3genre/mp3genre.o $(LIBS) -ldl
 
 foo.Pre: foo.Pre.o
 	$(CC) -o $@ $< $(LIBS)
diff -ru --unidirectional-new-file footools-x86-x64-20111102/src/pre/mp3genre/compile.sh footools-x86-x64-20111102-mp3genre/src/pre/mp3genre/compile.sh
--- footools-x86-x64-20111102/src/pre/mp3genre/compile.sh	1970-01-01 01:00:00.000000000 +0100
+++ footools-x86-x64-20111102-mp3genre/src/pre/mp3genre/compile.sh	2013-12-20 21:09:04.000000000 +0100
@@ -0,0 +1,4 @@
+#!/bin/sh
+CC=`which gcc`
+if [ -f mp3genre.o ]; then rm mp3genre.o; fi
+$CC -c mp3genre.c
diff -ru --unidirectional-new-file footools-x86-x64-20111102/src/pre/mp3genre/mp3genre.c footools-x86-x64-20111102-mp3genre/src/pre/mp3genre/mp3genre.c
--- footools-x86-x64-20111102/src/pre/mp3genre/mp3genre.c	1970-01-01 01:00:00.000000000 +0100
+++ footools-x86-x64-20111102-mp3genre/src/pre/mp3genre/mp3genre.c	2013-12-20 21:09:04.000000000 +0100
@@ -0,0 +1,38 @@
+/*
+ * slv 02082012 - mp3genre.c:
+ *
+ *	reads last 128 bytes of mp3 and extracts genre tag
+ *	ph33r my ugly "code" ;o
+ *
+ * this file is based in part on:
+ *
+ *	* MP3Info 0.5 by Ricardo Cerqueira <rmc@rccn.net>
+ * 	* MP3Stat 0.9 by Ed Sweetman <safemode@voicenet.com> and
+ *                       Johannes Overmann <overmann@iname.com>
+ *
+*/
+
+#include "mp3genre.h"
+
+int get_mp3_genre(const char* filename) {
+	FILE *fp;
+	unsigned char id3_genre_num[1];
+	char *id3_genre = "n/a";
+	char mp3_fbuf[2];
+	if (!(fp=fopen(filename,"rb"))) {
+		return 1;
+	}
+	if (fseek(fp,-128,SEEK_END)) {
+		return 1;
+	} else {
+	        fread(mp3_fbuf,1,3,fp); mp3_fbuf[3] = '\0';
+	        id3_genre_num[0]=255;
+		if (!strcmp((const char *)"TAG",(const char *)mp3_fbuf)) {
+		        fseek(fp, -1, SEEK_END);
+			fread(id3_genre_num,1,1,fp);
+			if(id3_genre_num[0] != '\0' && id3_genre_num[0] > 0 && id3_genre_num[0] < genre_count) {
+				id3_genre = genre_s[id3_genre_num[0]];
+			}
+		}
+	}
+}
diff -ru --unidirectional-new-file footools-x86-x64-20111102/src/pre/mp3genre/mp3genre.h footools-x86-x64-20111102-mp3genre/src/pre/mp3genre/mp3genre.h
--- footools-x86-x64-20111102/src/pre/mp3genre/mp3genre.h	1970-01-01 01:00:00.000000000 +0100
+++ footools-x86-x64-20111102-mp3genre/src/pre/mp3genre/mp3genre.h	2013-12-20 21:09:04.000000000 +0100
@@ -0,0 +1,50 @@
+/*
+ * slv 02082012 - headers for mp3genre.c
+ *
+ * from pzs-ng zipscript/src/multimedia.c
+ * http://www.pzs-ng.com
+ *
+*/
+#include <stdio.h>
+
+char *genre_s[] = {
+	"Blues", "Classic Rock", "Country", "Dance",
+	"Disco", "Funk", "Grunge", "Hip-Hop",
+	"Jazz", "Metal", "New Age", "Oldies",
+	"Other", "Pop", "R&B", "Rap",
+	"Reggae", "Rock", "Techno", "Industrial",
+	"Alternative", "Ska", "Death Metal", "Pranks",
+	"Soundtrack", "Euro-Techno", "Ambient", "Trip-Hop",
+	"Vocal", "Jazz+Funk", "Fusion", "Trance",
+	"Classical", "Instrumental", "Acid", "House",
+	"Game", "Sound Clip", "Gospel", "Noise",
+	"AlternRock", "Bass", "Soul", "Punk",
+	"Space", "Meditative", "Instrumental Pop", "Instrumental Rock",
+	"Ethnic", "Gothic", "Darkwave", "Techno-Industrial",
+	"Electronic", "Pop-Folk", "Eurodance", "Dream",
+	"Southern Rock", "Comedy", "Cult", "Gangsta",
+	"Top 40", "Christian Rap", "Pop_Funk", "Jungle",
+	"Native American", "Cabaret", "New Wave", "Psychadelic",
+	"Rave", "Showtunes", "Trailer", "Lo-Fi",
+	"Tribal", "Acid Punk", "Acid Jazz", "Polka",
+	"Retro", "Musical", "Rock & Roll", "Hard Rock",
+	"Folk", "Folk-Rock", "National Folk", "Swing",
+	"Fast Fusion", "Bebob", "Latin", "Revival",
+	"Celtic", "Bluegrass", "Avantgarde", "Gothic Rock",
+	"Progressive Rock", "Psychedelic Rock", "Symphonic Rock", "Slow Rock",
+	"Big Band", "Chorus", "Easy Listening", "Acoustic",
+	"Humour", "Speech", "Chanson", "Opera",
+	"Chamber Music", "Sonata", "Symphony", "Booty Bass",
+	"Primus", "Porn Groove", "Satire", "Slow Jam",
+	"Club", "Tango", "Samba", "Folklore",
+	"Ballad", "Power Ballad", "Rhythmic Soul", "Freestyle",
+	"Duet", "Punk Rock", "Drum Solo", "A cappella",
+	"Euro-House", "Dance Hall", "Goa", "Drum & Bass",
+	"Club House", "Hardcore", "Terror", "Indie",
+	"BritPop", "Negerpunk", "Polsk Punk", "Beat",
+	"Christian Gangsta Rap", "Heavy Metal", "Black Metal", "Crossover",
+	"Contemporary Christian", "Christian Rock", "Merengue", "Salsa",
+	"Thrash Metal", "Anime", "JPop", "Synthpop",
+	"Unknown"
+};
+unsigned char genre_count=149;
